diff --git a/sysdeps/ieee754/ldbl-128ibm-compat/Versions b/sysdeps/ieee754/ldbl-128ibm-compat/Versions
index 322041132e..f4047f06a6 100644
--- a/sysdeps/ieee754/ldbl-128ibm-compat/Versions
+++ b/sysdeps/ieee754/ldbl-128ibm-compat/Versions
@@ -111,3 +111,11 @@ libm {
     __ynieee128;
   }
 }
+libc {
+  LDBL_IBM128_VERSION {
+    __strfromieee128;
+    __strtoieee128;
+    __strtoieee128_l;
+    __wcstoieee128;
+    __wcstoieee128_l;
+  }
diff --git a/sysdeps/ieee754/ldbl-128ibm-compat/strfromf128.c b/sysdeps/ieee754/ldbl-128ibm-compat/strfromf128.c
new file mode 100644
index 0000000000..f3a646c9a9
--- /dev/null
+++ b/sysdeps/ieee754/ldbl-128ibm-compat/strfromf128.c
@@ -0,0 +1,21 @@
+/* Definitions for strfromf128.
+
+   Copyright (C) 2018 Free Software Foundation, Inc.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+#include "../float128/strfromf128.c"
+
+libm_alias_float128_other_r_ldbl (strfrom, strfrom,);
diff --git a/sysdeps/ieee754/ldbl-128ibm-compat/strtof128.c b/sysdeps/ieee754/ldbl-128ibm-compat/strtof128.c
new file mode 100644
index 0000000000..7980ca389b
--- /dev/null
+++ b/sysdeps/ieee754/ldbl-128ibm-compat/strtof128.c
@@ -0,0 +1,20 @@
+/* Definition of strtof128.
+   Copyright (C) 2018 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+#include "../float128/strtof128.c"
+libm_alias_float128_other_r_ldbl (strto, strto,);
diff --git a/sysdeps/ieee754/ldbl-128ibm-compat/strtof128_l.c b/sysdeps/ieee754/ldbl-128ibm-compat/strtof128_l.c
new file mode 100644
index 0000000000..ecb1e0c44b
--- /dev/null
+++ b/sysdeps/ieee754/ldbl-128ibm-compat/strtof128_l.c
@@ -0,0 +1,20 @@
+/* Convert string representing a number to a _Float128 value, with locale.
+   Copyright (C) 2018 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+#include "../float128/strtof128_l.c"
+libm_alias_float128_other_r_ldbl (strto, strto,_l);
diff --git a/sysdeps/ieee754/ldbl-128ibm-compat/wcstof128.c b/sysdeps/ieee754/ldbl-128ibm-compat/wcstof128.c
new file mode 100644
index 0000000000..edef95b969
--- /dev/null
+++ b/sysdeps/ieee754/ldbl-128ibm-compat/wcstof128.c
@@ -0,0 +1,20 @@
+/* Wrapper for wcstof128.
+   Copyright (C) 2018 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+#include "../float128/wcstof128.c"
+libm_alias_float128_other_r_ldbl (wcsto, wcsto,);
diff --git a/sysdeps/ieee754/ldbl-128ibm-compat/wcstof128_l.c b/sysdeps/ieee754/ldbl-128ibm-compat/wcstof128_l.c
new file mode 100644
index 0000000000..a95cde0ca3
--- /dev/null
+++ b/sysdeps/ieee754/ldbl-128ibm-compat/wcstof128_l.c
@@ -0,0 +1,20 @@
+/* Convert string representing a number to a _Float128 value, with locale.
+   Copyright (C) 2018 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+#include "../float128/wcstof128_l.c"
+libm_alias_float128_other_r_ldbl (wcsto, wcsto,_l);